#include "KColorTheme.h"
#include <afxdlgs.h>
#include <time.h>

//#define GetRValue(rgb)  ((BYTE)(rgb))
//#define GetGValue(rgb)  ((BYTE)(((WORD)(rgb)) >> 8))
//#define GetBValue(rgb)  ((BYTE)((rgb)>>16))

int basis_num = 4;
const char *src_path = "E:/src.jpg";
ThemeExtraction src_te(src_path, basis_num);

int kNum = 0;
Mat source_rgbThemes, modifed_rgbThemes;
Mat rgbThemes_img;
Mat src, result_image;
int pt_x, pt_y;
int colorIndex = 0;
int pick_r = 0, pick_g = 0, pick_b = 0;
int color_dialog_count = 0;
int midButtonClickCount = 0;

char *palette_path = "E:/result_palette_";
char *res_path = "E:/recoloring_res_";

void updateThemes()
{
	float r = pick_r / 255.0f;
	float g = pick_g / 255.0f;
	float b = pick_b / 255.0f;

	modifed_rgbThemes.at<Vec3f>(0, colorIndex)[0] = b;
	modifed_rgbThemes.at<Vec3f>(0, colorIndex)[1] = g;
	modifed_rgbThemes.at<Vec3f>(0, colorIndex)[2] = r;

	for (int j = 0; j < 100; j++)
	{
		for (int k = 0; k < 100; k++)
		{
			rgbThemes_img.at<Vec3f>(j, colorIndex*100 + k)[0] = b;
			rgbThemes_img.at<Vec3f>(j, colorIndex*100 + k)[1] = g;
			rgbThemes_img.at<Vec3f>(j, colorIndex*100 + k)[2] = r;
		}
	}
}

void validateThemeImage()
{
	imshow("color_palette", rgbThemes_img); 
}
void validateResultImage()
{
	imshow("image", result_image);
}

void themes2Image()
{
	for (int i = 0; i < kNum; i++)
	{
		for (int j = 0; j < 100; j++)
		{
			for (int k = 0; k < 100; k++)
			{
				rgbThemes_img.at<Vec3f>(j, i*100 + k)[0] = modifed_rgbThemes.at<Vec3f>(0, i)[0];
				rgbThemes_img.at<Vec3f>(j, i*100 + k)[1] = modifed_rgbThemes.at<Vec3f>(0, i)[1];
				rgbThemes_img.at<Vec3f>(j, i*100 + k)[2] = modifed_rgbThemes.at<Vec3f>(0, i)[2];
			}
		}
	}

	//rgbThemes_img.convertTo(rgbThemes_img, CV_32FC3, 255.0);
}

void saveResPalette()
{
	rgbThemes_img.convertTo(rgbThemes_img, CV_32FC3, 255.0);
	
	char buf[256];
	sprintf_s(buf, 256, "%s%d.png", palette_path, midButtonClickCount);
	imwrite(buf, rgbThemes_img);
}

void saveRecoloringRes()
{
	result_image.convertTo(result_image, CV_32FC3, 255.0);

	char buf[256];
	sprintf_s(buf, 256, "%s%d.png", res_path, midButtonClickCount);
	imwrite(buf, result_image);
}


void on_mouse( int event, int x, int y, int flags, void* ustc)    
{    
	if(event == CV_EVENT_LBUTTONDOWN && !color_dialog_count)  // for modify the color palette
	{
		//cout<<color_dialog_count<<endl;
		pt_x = x;
		pt_y = y;

		colorIndex = x / 100;
		
		int r = (int)(255.0 * modifed_rgbThemes.at<Vec3f>(0, colorIndex)[2]);
		int g = (int)(255.0 * modifed_rgbThemes.at<Vec3f>(0, colorIndex)[1]);
		int b = (int)(255.0 * modifed_rgbThemes.at<Vec3f>(0, colorIndex)[0]);

		COLORREF initColor = RGB(r, g, b);
		CColorDialog colorDlg(initColor,CC_FULLOPEN);
		//HWND hWnd = colorDlg.GetSafeHwnd();
		color_dialog_count++;

		//cout<<color_dialog_count<<"-";
			
		if (IDOK == colorDlg.DoModal())
		{
			initColor = colorDlg.GetColor();      // ȡɫԻѡɫֵ
			pick_r = GetRValue(initColor);
			pick_g = GetGValue(initColor);
			pick_b = GetBValue(initColor);

			updateThemes();
			validateThemeImage();

			Mat lab_themes;
			cvtColor(modifed_rgbThemes, lab_themes, CV_BGR2Lab);
			Mat res = src_te.colorThemeTransfer(lab_themes);
			res.copyTo(result_image);
			validateResultImage();

			color_dialog_count--;
			//cout<<color_dialog_count<<endl;
		}
		else
		{
			color_dialog_count = 0;
		}
	}

	if(event == CV_EVENT_RBUTTONDOWN) // reset the color palette
	{
		source_rgbThemes.copyTo(modifed_rgbThemes);
		src.copyTo(result_image);
		themes2Image();
		validateThemeImage();
		validateResultImage();
	}

	if (event == CV_EVENT_MBUTTONDOWN)  // save the result
	{
		midButtonClickCount++;
		saveResPalette();
		saveRecoloringRes();
		//exit(-1);
	}

	if (event == CV_EVENT_RBUTTONDBLCLK)
	{
		exit(-1);
	}
}    

int main()
{
	char *wMapPath = "E:/";
	kNum = basis_num;
	int res_rows = 100;
	int res_cols = 100 * basis_num;
	rgbThemes_img = Mat::zeros(res_rows, res_cols, CV_32FC3);

	src = imread(src_path);
	result_image = src.clone();

	Mat rgbThemes = src_te.getRGBThemes();
	modifed_rgbThemes = rgbThemes.clone();
	source_rgbThemes = rgbThemes.clone();
	themes2Image();

	clock_t t1 = clock();
	src_te.colorThemeDecompose();
	clock_t t2 = clock();
	double lapse_time = 1000.0 * (t2 - t1) / CLOCKS_PER_SEC;
	cout<<"time lapse: "<<lapse_time<<endl;

	src_te.testDecomposition();
	//src_te.visualizeLayers(wMapPath);
	src_te.visualizeCoeffWithRGBPaletteColor(wMapPath);

	namedWindow("image", 1);
	namedWindow("color_palette", 1);

	imshow("image", result_image);
	imshow("color_palette", rgbThemes_img);
	
	Mat source_theme_img = rgbThemes_img.clone();
	source_theme_img.convertTo(source_theme_img, CV_32FC3, 255.0);
	imwrite("E:/source_palette.png", source_theme_img);

	cvSetMouseCallback("color_palette", on_mouse, NULL);
	cvWaitKey(0);
	return 0;
}
